#include <cstdio>

// dependance de c-pragma.h
#include <gcc-plugin.h>
// c_register_pragma
#include <c-family/c-pragma.h>
// IDENTIFIER_POINTER
#include <tree.h>

#include "mpi_collective.hpp"

void register_mpicoll_check_pragma(void *event_data, void *data)
{
	(void) event_data;
	(void) data;
	printf("registering pragma: \"ProjectCA\"\n");
	c_register_pragma("ProjetCA", "mpicoll_check", mpicoll_check_pragma);
}

void mpicoll_check_pragma(cpp_reader *)
{
	location_t loc;
	cpp_ttype token;
	tree x;

	// on a pas acces a la fonction courante sans passer par cfun
	if (cfun)
	{
		printf("#pragma ProjectCA mpicoll_check is not allowed inside functions");
		return;
	}

	token = pragma_lex(&x, &loc);
	if (token == CPP_NAME)
	{
		printf("adding %s to function to parse.\n", IDENTIFIER_POINTER(x));
	}

}

void verify_mpicoll_list(void *event_data, void *data)
{
	(void) event_data;
	(void) data;
	printf("In verify mpicoll list\n");
}
